## pgcharts 1.0+2017-09

=== Makefile ===
# ql-to-deb build tool
APP_NAME   = pgcharts

# use either sbcl or ccl
CL	   = sbcl

SRC       = pgcharts.asd                  \
            $(wildcard src/*lisp)         \
            $(wildcard src/utils/*lisp)   \
            $(wildcard src/sql/*lisp)     \
            $(wildcard src/sql/*sql)

BUILDDIR   = build
LIBS       = $(BUILDDIR)/libs.stamp
QLDIR      = $(BUILDDIR)/quicklisp
QUICKLISP  = $(BUILDDIR)/quicklisp.lisp
MANIFEST   = $(BUILDDIR)/manifest.ql
PGCHARTS   = $(BUILDDIR)/bin/$(APP_NAME)

BUILDAPP_CCL  = $(BUILDDIR)/bin/buildapp.ccl
BUILDAPP_SBCL = $(BUILDDIR)/bin/buildapp.sbcl

ifeq ($(CL),sbcl)
BUILDAPP   = $(BUILDAPP_SBCL)
CL_OPTS    = --no-sysinit --no-userinit
else
BUILDAPP   = $(BUILDAPP_CCL)
CL_OPTS    = --no-init
endif

COMPRESS_CORE ?= yes

ifeq ($(CL),sbcl)
ifeq ($(COMPRESS_CORE),yes)
COMPRESS_CORE_OPT = --compress-core
else
COMPRESS_CORE_OPT = 
endif
endif

# ifeq ($(CL),sbcl)
# BUILDAPP_OPTS =          --require sb-posix
# endif

DEBUILD_ROOT = /tmp/pgcharts

all: $(PGCHARTS)

docs:
	ronn -roff pgcharts.1.md

clean:
	rm -rf $(LIBS) $(QUICKLISP) $(QLDIR) $(MANIFEST) $(BUILDAPP) $(PGCHARTS)

$(QLDIR)/setup.lisp:
	mkdir -p $(BUILDDIR)
	curl -o $(QUICKLISP) http://beta.quicklisp.org/quicklisp.lisp
	$(CL) $(CL_OPTS) --load $(QUICKLISP) \
             --eval '(quicklisp-quickstart:install :path "$(BUILDDIR)/quicklisp")' \
             --eval '(quit)'

quicklisp: $(QLDIR)/setup.lisp ;

$(LIBS): $(QLDIR)/setup.lisp
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                 \
             --eval '(push "$(CURDIR)/" asdf:*central-registry*)'   \
             --eval '(ql:quickload "pgcharts")'                     \
             --eval '(quit)'
	touch $@

libs: $(LIBS) ;

$(MANIFEST): $(LIBS)
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp                \
             --eval '(ql:write-asdf-manifest-file "$(MANIFEST)")'  \
             --eval '(quit)'

manifest: $(MANIFEST) ;

$(BUILDAPP_CCL): $(QLDIR)/setup.lisp
	mkdir -p $(BUILDDIR)/bin
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp               \
             --eval '(ql:quickload "buildapp")'                   \
             --eval '(buildapp:build-buildapp "$@")'              \
             --eval '(quit)'

$(BUILDAPP_SBCL): $(QLDIR)/setup.lisp
	mkdir -p $(BUILDDIR)/bin
	$(CL) $(CL_OPTS) --load $(QLDIR)/setup.lisp               \
             --eval '(ql:quickload "buildapp")'                   \
             --eval '(buildapp:build-buildapp "$@")'              \
             --eval '(quit)'

buildapp: $(BUILDAPP) ;

$(PGCHARTS): $(MANIFEST) $(BUILDAPP) $(SRC)
	mkdir -p $(BUILDDIR)/bin
	$(BUILDAPP)      --logfile /tmp/build.log                \
                         $(BUILDAPP_OPTS)                        \
                         --sbcl $(CL)                            \
                         --require asdf                          \
                         --load-system asdf                      \
                         --asdf-tree $(QLDIR)/dists              \
                         --asdf-path .                           \
                         --load-system $(APP_NAME)               \
                         --load src/image.lisp                   \
                         --entry pgcharts:main                   \
                         --dynamic-space-size 4096               \
                         $(COMPRESS_CORE_OPT)                    \
                         --output $@

pgcharts: $(PGCHARTS) ;

deb:
	# intended for use on a debian system
	mkdir -p $(DEBUILD_ROOT) && rm -rf $(DEBUILD_ROOT)
	rsync -Ca --exclude=build    \
                  --exclude=.vagrant \
                  --exclude=web/*zip \
                  ./ $(DEBUILD_ROOT)/
	cd $(DEBUILD_ROOT) && make -f debian/rules orig
	cd $(DEBUILD_ROOT) && debuild -us -uc -sa
	cp -a /tmp/pgcharts_* build/

## pgcharts 1.0

=== debian/control ===
Source: pgcharts
Priority: extra
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Build-Depends: debhelper (>= 9), sbcl (>= 1.2.0), buildapp (>= 1.5), cl-asdf (>= 3.0.3), cl-postmodern, cl-simple-date, cl-esrap, cl-py-configparser, cl-split-sequence, cl-ppcre, cl-alexandria, cl-hunchentoot, cl-yason, cl-closer-mop, cl-daemon, cl-who, cl-bordeaux-threads (>= 0.8.3), cl-curry-compose-reader-macros, cl-metabang-bind, cl-graph, cl-trivial-backtrace, cl-drakma, ruby-ronn
Standards-Version: 3.9.6
Section: non-free/database
Homepage: https://github.com/dimitri/pgcharts
Vcs-Git: https://github.com/dimitri/pgcharts.git
Vcs-Browser: https://github.com/dimitri/pgcharts

Package: pgcharts
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Description: turn your PostgreSQL queries into charts
 pgcharts is a little web application that takes as input an SQL query text
 and outputs its data in one of the following forms: html table, column
 chart, bar chart, pie chart, donut chart.

## pgcharts 1.0+2017-09-16

=== debian/changelog ===
pgcharts (1.0+2017-09-16-1) unstable; urgency=medium

  * Team upload with new upstream snapshot.
  * Add B-D on cl-named-readtables. (Closes: #880090)
  * Remove /var/log/pgcharts/ on purge. (Closes: #814653)
  * Remove debian/home/ on clean.
  * Priority: optional.
  * Run wrap-and-sort -st.

 -- Christoph Berg <myon@debian.org>  Sun, 13 Jan 2019 12:59:09 +0100

pgcharts (1.0-2) unstable; urgency=medium

  * Improve packaging with a system pgcharts user

 -- Dimitri Fontaine <dim@tapoueh.org>  Thu, 03 Sep 2015 16:28:44 +0300

pgcharts (1.0-1) unstable; urgency=medium

  * First release.

 -- Dimitri Fontaine <dim@tapoueh.org>  Wed, 10 Sep 2014 16:38:38 +0400

=== debian/control ===
Source: pgcharts
Priority: optional
Maintainer: Dimitri Fontaine <dim@tapoueh.org>
Build-Depends:
 buildapp (>= 1.5),
 cl-alexandria,
 cl-asdf (>= 3.0.3),
 cl-bordeaux-threads (>= 0.8.3),
 cl-closer-mop,
 cl-curry-compose-reader-macros,
 cl-daemon,
 cl-drakma,
 cl-esrap,
 cl-graph,
 cl-hunchentoot,
 cl-metabang-bind,
 cl-named-readtables,
 cl-postmodern,
 cl-ppcre,
 cl-py-configparser,
 cl-simple-date,
 cl-split-sequence,
 cl-trivial-backtrace,
 cl-who,
 cl-yason,
 debhelper (>= 9),
 ruby-ronn,
 sbcl (>= 1.2.0),
Standards-Version: 4.3.0
Section: non-free/database
Homepage: https://github.com/dimitri/pgcharts
Vcs-Git: https://github.com/dimitri/pgcharts.git
Vcs-Browser: https://github.com/dimitri/pgcharts

Package: pgcharts
Architecture: any
Depends: adduser, ${misc:Depends}, ${shlibs:Depends}
Description: turn your PostgreSQL queries into charts
 pgcharts is a little web application that takes as input an SQL query text
 and outputs its data in one of the following forms: html table, column
 chart, bar chart, pie chart, donut chart.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PKGVERS = $(shell dpkg-parsechangelog | awk -F '[:-]' '/^Version:/ { print substr($$2, 2) }')
EXCLUDE = --exclude-vcs --exclude=debian --exclude=build --exclude=.vagrant

BITS = $(shell dpkg-architecture -qDEB_BUILD_ARCH_BITS)
ifeq ($(BITS),32)
SIZE=1024
else
SIZE=4096
endif

# buildd provides a build environment where $HOME is not writable, but the
# CL compilers here will need to fill-in a per-user cache
export HOME = $(CURDIR)/debian/home

orig: clean
	cd .. && tar czf pgcharts_$(PKGVERS).orig.tar.gz $(EXCLUDE) pgcharts

override_dh_auto_build:
	mkdir -p build/bin
	mkdir -p $(HOME)
	buildapp --logfile /tmp/pgcharts-build.log          \
                 --require sb-posix                         \
                 --load /usr/share/common-lisp/source/cl-asdf/build/asdf.lisp \
                 --asdf-path .                              \
                 --asdf-tree /usr/share/common-lisp/systems \
                 --load-system pgcharts               	    \
                 --load src/image.lisp                      \
                 --load debian/settings.lisp                \
                 --entry pgcharts:main                      \
                 --dynamic-space-size $(SIZE)               \
                 --compress-core                    	    \
                 --output build/bin/pgcharts

override_dh_auto_test:
	# no nothing

override_dh_strip:
	# do nothing

%:
	dh $@
